#Lab 7 for cpe 101 - reads in a text file of names and their popularity over
# the last 100 years and plots the popularity for a given name
# the user may choose to search for a name at the command prompt

import math
import random
import sys, pygame
from pygame.locals import *

# define some colors to be used for drawing
PURPLE = (240, 5, 213)
AQUA = (64, 255, 244)
AQUAG = (84, 204, 163)
BLUE = (84, 204, 255)
PBLUE = (61, 115, 255)
SEAGREEN = (44, 232, 140)
CELL = 400//11

#name data - has a name string and the popularity of that name
class nData:
   def __init__(self, in_name, in_rank) :
      self.name = in_name
      self.rankList = in_rank

#function to read in the text file and create a giant list of name data elements
def readData(theNames):
   f = open('names.txt', 'r')
   j = 0
   ranks = []

   while True:
      s = f.readline()
      if len(s) == 0:
         break
      #split the line apart
      l = s.split()
      #put each year's popularity into a list (not integars yet)
      for i in range(1, len(l)):
         ranks.append(l[i])
      #add the new name and its ranking over time
      theNames.append(nData(l[0], ranks))
      ranks = []
      j += 1

#currently draws a graph representing the popularity of the name at the
#specified index over time with ellipses and lines in between
def draw(screen, theNames, myFont, nameIndx):
   colors = [SEAGREEN, AQUA, BLUE, PBLUE, PURPLE]
   screen.fill((128, 128, 128))

   shiftUp = 10

   WriteName(screen, theNames[nameIndx], myFont, colors[0])
   for i in range(0, 11):
      CurY = (screen.get_height() - 
               int(theNames[nameIndx].rankList[i])*0.4 - shiftUp)
      pygame.draw.ellipse(screen, colors[0], Rect(i*CELL, CurY, 16, 16))
      #only draw lines between ellipses
      if i < 10:
         NextY = (screen.get_height() -
                   int(theNames[nameIndx].rankList[i+1])*0.4 -shiftUp)
         pygame.draw.line(screen, colors[0], (i*CELL+8, CurY+8), 
                                    ((i+1)*CELL+8, NextY+8), 2)


#looks through all the names for a particular one
def SearchName(theNames, string):
   for i in range(0, len(theNames)):
      if string == theNames[i].name:
         return i
   return -1

#writes out the name being graphed
def WriteName(screen, nameD, myfont, color):
   label = myfont.render("Name: " + str(nameD.name), 1, color)
   screen.blit(label, (10, 10))

#function to start up the main drawing
def main():

   pygame.init()
   width = 400
   height = 480
   screen = pygame.display.set_mode((width, height))
   theNames = []
   readData(theNames)
   nameIndx = 0

   #get my font ready for when I do print to the screen
   myfont = pygame.font.SysFont("monospace", 15)

   while True:
      for event in pygame.event.get():
         if event.type == QUIT: sys.exit()

      draw(screen, theNames, myfont, nameIndx)
      pygame.display.flip()
      #python3 no longer supports raw_input but lower versions do
      #var = raw_input("Enter a name to search for: ")
      var = input("Enter a name to search for: ")
      print("You entered " + str(var))
      curI = SearchName(theNames, str(var))
      if curI >= 0:
         nameIndx = curI
      else:
         print("Name not found using default name A")
         nameIndx = 0
         

if __name__ == '__main__':
   main()

